
<!doctype html>

<html>
<head>
  <meta name="viewport" content="width=device-width, minimum-scale=1.0, initial-scale=1.0, user-scalable=yes">
  <meta name="theme-color" content="#4F7DC9">
  <meta charset="UTF-8">
  <title>How to Run MAVROS on VOXL 2 with PX4</title>
  <script src="../../bower_components/webcomponentsjs/webcomponents-lite.min.js"></script>
  <link rel="import" href="../../elements/codelab.html">
  <link rel="stylesheet" href="//fonts.googleapis.com/css?family=Source+Code+Pro:400|Roboto:400,300,400italic,500,700|Roboto+Mono">
  <style>
    body {
      font-family: "Roboto",sans-serif;
    }
  </style>
  
</head>
<body unresolved class="fullbleed">

  <google-codelab title="How to Run MAVROS on VOXL 2 with PX4"
                  environment="web"
                  feedback-link="https://forum.modalai.com">
    
      <google-codelab-step label="Introduction" duration="3">
        <p><strong>Last Updated: </strong>Oct 7, 2022</p>
<p>This tutorial demonstrates how to fly a VOXL2 / RB5 Flight based drone autonomously in a figure 8, using MAVROS.</p>
<p>For this setup, MAVROS is installed and runs on VOXL 2 / RB5 Flight. Additionally, the voxl-px4, voxl-vision-px4 and voxl-mavlink-server background services will be running. This provides the PX4 flight controller, Visual Inertial Odometry (VIO) for PX4, and manages the mavlink telemetry between the ground control station remotely and ROS locally.</p>
<p>WARNING: At the end of this tutorial, your drone will be flying autonomously. Please only run this in a safe location away from people and wear protective eyewear!!</p>
<h2><strong>Block Diagram</strong></h2>
<p><img style="max-width: 624.00px" src="img/606fc2e5abac3a89.png"></p>


      </google-codelab-step>
    
      <google-codelab-step label="Video Walkthrough" duration="18">
        <google-youtube fluid video-id="zTeWbBnCPuo"></google-youtube>


      </google-codelab-step>
    
      <google-codelab-step label="Prerequisites" duration="3">
        <h2><strong>Install ROS Melodic</strong></h2>
<ul>
<li>To install software using <code>apt</code>, please have vehicle <a href="https://docs.modalai.com/voxl2-networking-user-guide/" target="_blank">connected to the internet</a></li>
<li>Install ROS Melodic on VOXL 2 following <a href="https://docs.modalai.com/setup-ros-on-voxl-2/" target="_blank">this guide</a></li>
</ul>
<h2><strong>Install MAVROS Dependencies</strong></h2>
<ul>
<li>Install the following packages MAVROS packages:</li>
</ul>
<pre><code>$ apt-get install ros-melodic-mavros ros-melodic-mavros-extras ros-melodic-control-toolbox</code></pre>
<ul>
<li>Install <code>GeographicLib dataset</code>:</li>
</ul>
<pre><code>$ cd /opt/ros/melodic/lib/mavros 
$ ./install_geographiclib_datasets.sh</code></pre>
<h2><strong>Configure voxl-vision-px4 localhost</strong></h2>
<p>Use <code>voxl-inspect-services</code> to validate <code>voxl-vision-px4</code> is enabled.</p>
<p>Edit the configuration file</p>
<pre><code>$ vi /etc/modalai/voxl-vision-px4.conf</code></pre>
<p>We will check the following</p>
<ul>
<li><code>qgc_ip</code> - should be your host PCs IP address where the Ground Control Station is</li>
<li><code>en_localhost_mavlink_udp</code> - set to true to allow UDP MAVLink comms on localhost</li>
<li><code>offboard_mode</code> - set to &#34;off&#34; since we will not use VVPX4 for offboard mode, but use MAVROS instead</li>
</ul>
<p>Validate your configuration file</p>
<pre><code> &#34;qgc_ip&#34;:                     &#34;X.X.X.X&#34;,
  &#34;en_localhost_mavlink_udp&#34;:   true,
  ...
  &#34;offboard_mode&#34;:              &#34;off&#34;</code></pre>
<h2><strong>Configure voxl-mavlink-server</strong></h2>
<p>Use <code>voxl-inspect-services</code> to validate <code>voxl-mavlink-server</code> is enabled.</p>


      </google-codelab-step>
    
      <google-codelab-step label="mavros_test Project (simple-example)" duration="6">
        <h2><strong>Checklist</strong></h2>
<ol type="1" start="1">
<li>Make sure your drone can arm</li>
<li>Have RC transmitter bound to vehicle with ‘offboard&#39; and ‘manual&#39; mode</li>
<li>This simple-example can be done on the bench <strong>WITHOUT PROPS</strong></li>
</ol>
<h2><strong>Overview</strong></h2>
<p>This <code>simple-example</code> branch demo project:</p>
<ol type="1" start="1">
<li>waits for offboard mode</li>
<li>arms the vehicle</li>
<li>disarms the vehicle</li>
</ol>
<h2><strong>Build</strong></h2>
<p>On VOXL 2 / RB5 Flight, clone the <code>simple-example</code> branch of the <code>mavros_test</code> project. In this example, we&#39;re cloning to <code>/home</code>:</p>
<pre><code>$ cd /home
$ git clone -b simple-example https://gitlab.com/voxl-public/support/mavros_test.git</code></pre>
<p>Build the project:</p>
<pre><code>$ cd /home/mavros_test
$ ./build.sh

Base path: /home/mavros_test/catkin_ws
Source space: /home/mavros_test/catkin_ws/src
Build space: /home/mavros_test/catkin_ws/build
Devel space: /home/mavros_test/catkin_ws/devel
Install space: /home/mavros_test/catkin_ws/install
Creating symlink &#34;/home/mavros_test/catkin_ws/src/CMakeLists.txt&#34; pointing to &#34;/opt/ros/melodic/share/catkin/cmake/toplevel.cmake&#34;
...</code></pre>
<h2><strong>Configure ROS ENV</strong></h2>
<p>The <code>ros_environment.sh</code> file contains environment variables used by ROS.</p>
<p>Update the <code>ROS_IP</code> value to use your IP address on target (you can use <code>ifconfig</code>):</p>
<pre><code>$ more /home/mavros_test/ros_environment.sh

#!/bin/bash
#

source /opt/ros/kinetic/setup.bash
source catkin_ws/install/setup.bash
unset ROS_HOSTNAME

# configure ROS IPs here
export ROS_MASTER_IP=127.0.0.1
export ROS_IP=192.168.8.1
export ROS_MASTER_URI=http://${ROS_MASTER_IP}:11311/
# mavros needs to know what PX4&#39;s system id is
export PX4_SYS_ID=1</code></pre>


      </google-codelab-step>
    
      <google-codelab-step label="Launch the simple-example Demo" duration="3">
        <p>You can do this on bench top if you&#39;d like, but <strong>REMOVE THE PROPELLERS</strong> as this will arm the drone!</p>
<ul>
<li>Open an adb shell</li>
<li>Run the following to launch the program</li>
</ul>
<pre><code>$ cd /home/mavros_test
$ ./run_mavros_test.sh</code></pre>
<p>You should get an output that ends similar to this:</p>
<pre><code>...
 INFO] [1663886683.264138601]: MAVROS started. MY ID 1.240, TARGET ID 1.1
[ INFO] [1663886683.264246359]: udp0: Remote address: 127.0.0.1:38711
[ INFO] [1663886683.264606406]: IMU: Attitude quaternion IMU detected!
[ INFO] [1663886683.265673318]: IMU: High resolution IMU detected!
[ WARN] [1663886683.267312670]: GP: No GPS fix
[ INFO] [1663886683.313571850]: CON: Got HEARTBEAT, connected. FCU: PX4 Autopilot
[ INFO] [1663886683.315295002]: IMU: High resolution IMU detected!
[ INFO] [1663886683.378609250]: IMU: Attitude quaternion IMU detected!
[ INFO] [1663886684.337418988]: GF: Using MISSION_ITEM_INT
[ INFO] [1663886684.337929605]: RP: Using MISSION_ITEM_INT
[ INFO] [1663886684.338302621]: WP: Using MISSION_ITEM_INT
[ INFO] [1663886684.338667459]: VER: 1.1: Capabilities         0x000000000000e4ef
[ INFO] [1663886684.339006205]: VER: 1.1: Flight software:     01041040 (33795a0a30000000)
[ INFO] [1663886684.339548645]: VER: 1.1: Middleware software: 01041040 (33795a0a30000000)
[ INFO] [1663886684.339894838]: VER: 1.1: OS software:         04137dff (e7701b9e792e3101)
[ INFO] [1663886684.340202177]: VER: 1.1: Board hardware:      00000001
[ INFO] [1663886684.340527172]: VER: 1.1: VID/PID:             0000:0000
[ INFO] [1663886684.340860813]: VER: 1.1: UID:                 3044494530303030
[ WARN] [1663886684.341231173]: CMD: Unexpected command 520, result 0
[ INFO] [1663886687.929310850]: waiting for offboard mode
[ INFO] [1663886693.315015302]: HP: requesting home position
[ INFO] [1663886696.836791903]: RC_CHANNELS message detected!
[ INFO] [1663886698.315995312]: RP: mission received
[ INFO] [1663886698.317024880]: GF: mission received
[ INFO] [1663886698.317390396]: WP: mission received
[ INFO] [1663886703.314904662]: HP: requesting home position
[ INFO] [1663886707.538530390]: VER: 1.1: Capabilities         0x000000000000e4ef
[ INFO] [1663886707.538779396]: VER: 1.1: Flight software:     01041040 (33795a0a30000000)
[ INFO] [1663886707.538893405]: VER: 1.1: Middleware software: 01041040 (33795a0a30000000)
[ INFO] [1663886707.539031580]: VER: 1.1: OS software:         04137dff (e7701b9e792e3101)
[ INFO] [1663886707.539153506]: VER: 1.1: Board hardware:      00000001
[ INFO] [1663886707.539264337]: VER: 1.1: VID/PID:             0000:0000
[ INFO] [1663886707.539952557]: VER: 1.1: UID:                 3044494530303030
[ WARN] [1663886707.540114325]: CMD: Unexpected command 512, result 0
[ INFO] [1663886707.708296390]: VER: 1.1: Capabilities         0x000000000000e4ef
[ INFO] [1663886707.708538834]: VER: 1.1: Flight software:     01041040 (33795a0a30000000)
[ INFO] [1663886707.708672791]: VER: 1.1: Middleware software: 01041040 (33795a0a30000000)
[ INFO] [1663886707.708817060]: VER: 1.1: OS software:         04137dff (e7701b9e792e3101)
[ INFO] [1663886707.708943881]: VER: 1.1: Board hardware:      00000001
[ INFO] [1663886707.709068618]: VER: 1.1: VID/PID:             0000:0000
[ INFO] [1663886707.709161221]: VER: 1.1: UID:                 3044494530303030
[ INFO] [1663886708.451312390]: WP: seems GCS requesting mission
[ INFO] [1663886708.452393312]: WP: scheduling pull after GCS is done
[ INFO] [1663886708.566541986]: GF: seems GCS requesting mission
[ INFO] [1663886708.566864534]: GF: scheduling pull after GCS is done
[ INFO] [1663886708.610489220]: RP: seems GCS requesting mission
[ INFO] [1663886708.611010150]: RP: scheduling pull after GCS is done
[ INFO] [1663886713.314919596]: HP: requesting home position
[ WARN] [1663886713.449405269]: GP: No GPS fix
[ INFO] [1663886713.456587822]: WP: mission received
[ INFO] [1663886713.568093669]: GF: mission received
[ INFO] [1663886713.612369544]: RP: mission received
[ INFO] [1663886723.314870316]: HP: requesting home position
[ INFO] [1663886726.379315832]: arming
[ INFO] [1663886726.427174936]: FCU: Armed by external command
[ INFO] [1663886726.428385127]: Vehicle armed
[ INFO] [1663886726.476409542]: FCU: [logger] /data/px4/log/sess005/log001.ulg
[ INFO] [1663886731.379187081]: disarming
[ INFO] [1663886731.395421067]: FCU: Disarmed by external command
[ INFO] [1663886731.396092620]: Vehicle disarmed
[ INFO] [1663886731.396233503]: done
[mavros_test_node-3] process has finished cleanly
log file: /home/root/.ros/log/25b80dbe-3ac8-11ed-b22c-00c0caafc7f0/mavros_test_node-3*.log
...</code></pre>


      </google-codelab-step>
    
  </google-codelab>

  <script>
    (function(i,s,o,g,r,a,m){i['GoogleAnalyticsObject']=r;i[r]=i[r]||function(){
    (i[r].q=i[r].q||[]).push(arguments)},i[r].l=1*new Date();a=s.createElement(o),
    m=s.getElementsByTagName(o)[0];a.async=1;a.src=g;m.parentNode.insertBefore(a,m)
    })(window,document,'script','//www.google-analytics.com/analytics.js','ga');
    ga('create', 'UA-49880327-14', 'auto');

    (function() {
      var gaCodelab = '';
      if (gaCodelab) {
        ga('create', gaCodelab, 'auto', {name: 'codelab'});
      }

      var gaView;
      var parts = location.search.substring(1).split('&');
      for (var i = 0; i < parts.length; i++) {
        var param = parts[i].split('=');
        if (param[0] === 'viewga') {
          gaView = param[1];
          break;
        }
      }
      if (gaView && gaView !== gaCodelab) {
        ga('create', gaView, 'auto', {name: 'view'});
      }
    })();
  </script>

</body>
</html>
